package com.madeu.crm.feedbackReception.ctrl;

import java.util.HashMap;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.crm.feedbackReception.service.FeedbackReceptionService;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@Controller
public class FeedbackReceptionController {

    @Autowired
    private FeedbackReceptionService feedbackReceptionService;

    @Autowired
    private WebLogHistoryService webLogHistoryService;

    /**
     * 칭찬불만접수 게시판 이동
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/feedbackReception/moveFeedbackReceptionList.do")
    public String  moveFeedbackReceptionList(HttpSession session, HttpServletRequest request, HttpServletResponse response, Model model) {
        log.debug("moveFeedbackReceptionList START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = feedbackReceptionService.moveFeedbackReceptionList(paramMap);

            model.addAttribute("selectUseYn", map.get("selectUseYn"));
            model.addAttribute("insertUseYn", map.get("insertUseYn"));
            model.addAttribute("updateUseYn", map.get("updateUseYn"));
            model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
            model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
        }
        catch (Exception e) {
            e.printStackTrace();
            return "/web/login/logout";
        }
        log.debug("moveFeedbackReceptionList END");

        
        return "/web/feedbackReception/FeedbackReceptionList";
    }
    
    
    /**
     * 칭찬불만접수 게시판 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/feedbackReception/getFeedbackReceptionList.do")
    public ModelAndView getFeedbackReceptionList(HttpSession session, HttpServletRequest request, HttpServletResponse response) {
		log.debug("FeedbackReceptionController selectListFeedbackReception START");
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = feedbackReceptionService.getFeedbackReceptionList(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("FeedbackReceptionController selectListFeedbackReception END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    /**
     * 홈페이지 칭찬불만접수 정보 상세 조회
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/feedbackReception/getFeedbackReception.do")
    public ModelAndView getFeedbackReception(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("FeedbackReceptionController selectFeedbackReception START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            map = feedbackReceptionService.getFeedbackReception(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            return null;
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("FeedbackReceptionController selectFeedbackReception END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
    
    /**
     * 홈페이지 칭찬불만접수 정보 등록
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/feedbackReception/putFeedbackReception.do")
    public ModelAndView putFeedbackReception(@RequestBody HashMap<String, Object> paramMap, HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("FeedbackReceptionController putFeedbackReception START");

        HashMap<String, Object> map = new HashMap<String, Object>();
        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = feedbackReceptionService.putFeedbackReception(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/FeedbackReception/insertFeedbackReception.do");
                insertMap.put("func", "insertFeedbackReception");
                insertMap.put("funcName", "홈페이지 칭찬불만접수 등록");
                insertMap.put("service", "FeedbackReceptionService");
                insertMap.put("serviceName", "홈페이지 칭찬불만접수 등록");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("FeedbackReceptionController putFeedbackReception END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    

    /**
     * 홈페이지 칭찬불만접수 정보 수정
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping(value="/feedbackReception/modFeedbackReception.do")
    public ModelAndView modFeedbackReception(@RequestBody HashMap<String, Object> paramMap, HttpSession session,HttpServletRequest request, HttpServletResponse response) {
        log.debug("FeedbackReceptionController updateFeedbackReception START");

        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try{
            paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
            paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
            map = feedbackReceptionService.modFeedbackReception(paramMap);
        }
        catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        }
        finally {
            if(Constants.OK == map.get("msgCode")) {

            }
            else{
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            try {
                HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
                HashMap<String, Object> insertMap = new HashMap<String, Object>();

                insertMap.put("url", "/FeedbackReception/updateFeedbackReception.do");
                insertMap.put("func", "updateFeedbackReception");
                insertMap.put("funcName", "홈페이지 칭찬불만접수 수정");
                insertMap.put("service", "FeedbackReceptionService");
                insertMap.put("serviceName", "홈페이지 칭찬불만접수 수정");
                insertMap.put("requestValue", String.valueOf(paramMap));
                insertMap.put("responseValue", String.valueOf(map));
                insertMap.put("tId", map.get("tId"));
                if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
                    insertMap.put("resultCode", "SUCCESS");
                }
                else{
                    insertMap.put("resultCode", "ERROR");
                }
                insertMap.put("resultMsg", String.valueOf(errorMsg));
                insertMap.put("muMemberId", paramMap.get("loginMemberId"));

                webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
            }
            catch (Exception e) {
                e.printStackTrace();
            }
        }
        log.debug("FeedbackReceptionController updateFeedbackReception END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }


    
}


